﻿using Infragistics.Controls.Charts;
using Infragistics.Windows;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamDataChartDynamicSeriesCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ViewModel VM = new ViewModel();
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = VM;
            DataChart1.Series.CollectionChanged += Series_CollectionChanged;
        }

        void Series_CollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e)
        {
            if (e.NewItems != null)
            {
                LineSeries ls = e.NewItems[0] as LineSeries;

                LegendItem item = new LegendItem() { ChartSeries = ls };

                WrapPanel wp = Utilities.GetDescendantFromName(Legend, "WrapPanel1") as WrapPanel;
                
                wp.Children.Add(item);          
            }

        }

        private void XAxis_Loaded(object sender, RoutedEventArgs e)
        {
            ContentPresenter cp = Utilities.GetDescendantFromName(Legend, "ContentPresenter") as ContentPresenter;
            WrapPanel wp = new WrapPanel() { Orientation = System.Windows.Controls.Orientation.Horizontal, Name="WrapPanel1", MaxWidth=180 };
            cp.Content = wp;
        }

        private void Series1Btn_Click(object sender, RoutedEventArgs e)
        {
            LineSeries ls = new LineSeries();
            ls.XAxis = XAxis;
            ls.YAxis = YAxis;
            ls.ItemsSource = VM.Data;
            ls.Title = "Series 1";
            ls.ValueMemberPath = "Y1";
            ls.Brush = Brushes.Blue;


            DataChart1.Series.Add(ls);

            Series1Btn.IsEnabled = false;
        }

        private void Series2Btn_Click(object sender, RoutedEventArgs e)
        {
            LineSeries ls = new LineSeries();
            ls.XAxis = XAxis;
            ls.YAxis = YAxis;
            ls.ItemsSource = VM.Data;
            ls.Title = "Series 2";
            ls.ValueMemberPath = "Y2";
            ls.Brush = Brushes.Black;

            DataChart1.Series.Add(ls);

            Series2Btn.IsEnabled = false;
        }

        private void Series3Btn_Click(object sender, RoutedEventArgs e)
        {
            LineSeries ls = new LineSeries();
            ls.XAxis = XAxis;
            ls.YAxis = YAxis;
            ls.ItemsSource = VM.Data;
            ls.Title = "Series 3";
            ls.ValueMemberPath = "Y3";
            ls.Brush = Brushes.Red;

            DataChart1.Series.Add(ls);

            Series3Btn.IsEnabled = false;
        }

        private void Series4Btn_Click(object sender, RoutedEventArgs e)
        {
            LineSeries ls = new LineSeries();
            ls.XAxis = XAxis;
            ls.YAxis = YAxis;
            ls.ItemsSource = VM.Data;
            ls.Title = "Series 4";
            ls.ValueMemberPath = "Y4";
            ls.Brush = Brushes.Green;

            DataChart1.Series.Add(ls);

            Series4Btn.IsEnabled = false;
        }
    }
}
